// Header File
// Created 11/10/2004; 4:53:17 PM

void createGraphic(int type,int x,int y)
{
	if (graphics.curnum==graphics.max) return;
	GRAPHIC ret={type,x,y,0};
	graphics.p[graphics.curnum]=ret;
	graphics.curnum++;
	drawgraphic(x,y,type,0);
	if (type==3) speed-=explodeComp;
}

void updateGraphics(void)
{
	int i;
	int pd=1;
	for (i=0;i<graphics.curnum;i++)
	{
		pd=1;
		drawgraphic(graphics.p[i].x,graphics.p[i].y,graphics.p[i].type,graphics.p[i].phase);
		graphics.p[i].phase++;
		if (graphics.p[i].phase>maxgraphs[graphics.p[i].type])
		{
			deleteGraphic(i+1);
			i--;
			pd=0;
		}
		if (pd) drawgraphic(graphics.p[i].x,graphics.p[i].y,graphics.p[i].type,graphics.p[i].phase);
	}
}

void deleteGraphic(int num)
{
	if (num>graphics.curnum) return;
	if (graphics.p[num-1].type==2) deflectorRunning=0;
	if (graphics.p[num-1].type==3) speed+=explodeComp;
	int i;
	graphics.curnum--;
	for (i=num;i<=graphics.curnum;i++)
		graphics.p[i-1]=graphics.p[i];
}

void drawgraphic(int x,int y,int type,int phase)
{
	int i,a,ax,ay,b,phase2;
	if (type==0)
		draw16(x,y,16,graphicicons[type][phase],LCD_MEM,SPRT_XOR);
	if (type==1)
	{
		DrawClipEllipse(x/scale,y/scale,phase*3/2,phase*3/2,tScrRect,A_XOR);
		DrawClipEllipse(x/scale,y/scale,phase*3/2+1,phase*3/2+1,tScrRect,A_XOR);
	}
	if (type==2)
	{
		drawDeflector(phase);
		a=(bstatlineg-15)*scale;
		for (i=0;i<projectiles.curnum;i++)
		{
			if (projectiles.p[i].enemy&&projectiles.p[i].y>=a)
			{
				projectiles.p[i].enemy=0;
				if (projectiles.p[i].speedY>0) projectiles.p[i].speedY=-projectiles.p[i].speedY;
			}
		}
	}
	if (type==3)
	{
		a=2;
		DrawClipEllipse(x/scale,y/scale,phase*a/2,phase*a/2,tScrRect,A_XOR);
		phase2=20;
		if (phase>phase2) phase2=phase;
		ax=x-scale*(phase2*a/2);
		ay=y-scale*(phase2*a/2);
		a=scale*(phase2*a+1);
		for (i=0;i<bosses.curnum;i++)
		{
			if (overlaps(ax,ay,a,a,Boss.x,Boss.y,32*scale,32*scale))
			{
				createGraphic(1,Boss.x+16*scale,Boss.y+16*scale);
				drawboss(Boss.x,Boss.y,Boss.type,Boss.phase);
				deleteBoss(i+1);
				i--;
				status.points+=250;
				redrawPoints();
			}
		}
		for (i=0;i<enemies.curnum;i++)
		{
			if (level[Enemy.type-1].iconsize==8)
				b=8*scale;
			else
				b=16*scale;
			if (overlaps(ax,ay,a,a,Enemy.x,Enemy.y,b,b))
			{
				drawenemy(Enemy.x,Enemy.y,Enemy.type);
				if (level[Enemy.type-1].iconsize==8)
					createGraphic(0,Enemy.x-4*scale,Enemy.y-4*scale);
				else
					createGraphic(0,Enemy.x,Enemy.y);
				status.points+=50;
				redrawPoints();
				deleteEnemy(i+1);
				i--;
			}
		}
	}
}

void drawDeflector(int phase)
{
	int pp=phase%8;
	register char *ptr=LCD_MEM+30*(bstatlineg-15);
	register char *eptr=ptr+20;
	register char xordata=(0xF0>>pp)|(0xF0<<(8-pp));//0b11110000
	while (ptr<eptr) *(ptr++)^=xordata;
}