// Header File
// Created 11/14/2004; 6:07:13 PM

void level1_formation(void)
{
	int i,type=1;
	//int x=0,y=0;
	type=1;
	firecountmax=475;
	fcplus=25;
	enemies.curnum=0;
	for (i=0;i<=15;i++)
		createEnemy((10+i*8)*scale,(10+i*1)*scale,1*scale,1*scale,type,0);
	//createTimeEvent(startSaucer,0);
}

void level1_dynscript(int i)
{
	if ((Enemy.x<5*scale)|(Enemy.x>146*scale)) Enemy.speedX=-(Enemy.speedX);
	if ((Enemy.y<5*scale)|(Enemy.y>45*scale)) Enemy.speedY=-(Enemy.speedY);
}

void level2_formation(void)
{
	int i,type;
	//int x=0,y=0;
	type=2;
	firecountmax=300;
	fcplus=25;
	enemies.curnum=0;
	for (i=0;i<=6;i++)
		createEnemy((27+i*16)*scale,5*scale,1*scale,0,type,0);
	for (i=1;i<=3;i++)
		createEnemy((123-i*16)*scale,(5+i*16)*scale,-1*scale,1*scale,type,0);
	for (i=1;i<=2;i++)
		createEnemy((75-i*16)*scale,(53-i*16)*scale,-1*scale,-1*scale,type,0);
}

void level2_dynscript(int i)
{
	if (Enemy.x<27*scale)
	{
		Enemy.speedX=1*scale;
		Enemy.speedY=0;
	}
	if (Enemy.x>123*scale)
	{
		Enemy.speedX=-1*scale;
		Enemy.speedY=1*scale;
	}
	if (enemies.p[i].y>53*scale)
	{
		Enemy.speedX=-1*scale;
		Enemy.speedY=-1*scale;
	}
}

void level3_formation(void)
{
	int i,type;
	int x=0,y=0;
	type=3;
	firecountmax=125;
	fcplus=8;
	enemies.curnum=0;
	for (i=0;i<=14;i++)
	{
		convToCircle(i*24,&x,&y);
		createEnemy(x,y,0,0,type,i*24);
	}
}

void level3_dynscript(int i)
{
	Enemy.tag=(Enemy.tag+4)%360;
	convToCircle(Enemy.tag,&(Enemy.x),&(Enemy.y));
}

void level4_formation(void)
{
	int i;
	//int x=0,y=0;
	firecountmax=226;
	fcplus=8;
	enemies.curnum=0;
	addl4();
	for (i=1;i<=27;i++) createTimeEvent(addl4,i*4);
	createTimeEvent(startDropper,450);
}

void level4_dynscript(int i)
{
	correctDegrees(Enemy.tag);
	if (Enemy.tag2==0)
	{
		if (Enemy.x>130*scale)
			Enemy.tag3=-8;//turning	 angle
		else
		{
			if (Enemy.x<26*scale)
				Enemy.tag3=-8;
			else
			{
				Enemy.tag3=0;
				if (Enemy.speedX>0)
					{
						Enemy.tag=90;
						Enemy.y=0;
					}
				else
					Enemy.tag=270;
			}
		}
	}
	Enemy.tag+=Enemy.tag3;
	correctDegrees(Enemy.tag);
	degreesToXY(Enemy.tag,3*scale,0,0,&Enemy.speedX,&Enemy.speedY,1,1);
}

void level5_formation(void)
{
	int i,type;
	//int x=0,y=0;
	type=5;
	firecountmax=100;
	fcplus=6;
	enemies.curnum=0;
	for (i=0;i<=15;i++)
	{
		createEnemy(i*9*scale,i*3*scale,((1-(i%2))*2-1)*4*scale,i*scale/12,type,0);
	}
}

void level5_dynscript(int i)
{
	if (Enemy.x<2*scale&&Enemy.speedX<0)
		Enemy.speedX=-Enemy.speedX;
	if (Enemy.x>142*scale&&Enemy.speedX>0)
		Enemy.speedX=-Enemy.speedX;
	if (Enemy.y>47*scale&&Enemy.speedY>0)
		{
			Enemy.speedY=-Enemy.speedY;
			Enemy.y=47*scale;
		}
	Enemy.speedY+=scale/8;
}

void level6_formation(void)
{
	int i,type;
	//int x=0,y=0;
	type=6;
	firecountmax=149;//indivisible to prevent one-line firing
	fcplus=0;
	enemies.curnum=0;
	for (i=0;i<=24;i++)
	{
		createEnemy((i%5)*8*scale,(i/5)*8*scale,2*scale,0,type,0);
		thisEnemy.tag10=i%5;//x coordinate in formation
		thisEnemy.tag9=i/5;//y coordinate in formation
	}
}

void level6_dynscript(int i)
{
	int a;
	a=Enemy.tag10*8*scale;//x position of enemy on formation
	if (Enemy.speedX>0&&Enemy.x>=120*scale+a)
	{
		Enemy.speedX=0;
		Enemy.speedY=2*scale;
		Enemy.x=120*scale+a;
		Enemy.tag8=-2*scale;
	}
	else if (Enemy.speedX<0&&Enemy.x<=a)
	{
		Enemy.speedX=0;
		Enemy.speedY=2*scale;
		Enemy.x=a;
		Enemy.tag8=2*scale;
	}
	else if (Enemy.speedY>0)
	{
		Enemy.speedX=Enemy.tag8;
		Enemy.speedY=0;
	}
	if (colDet16(icons[1],smallicons[4],yourShip.x,shipY,Enemy.x,Enemy.y))
	{
		drawenemy(Enemy.x,Enemy.y,Enemy.type);
		wipeOutEnemy(0);
		killYou();
		return;
	}
}

void level7_formation(void)
{
	int i,type;
	//int x=0,y=0;
	type=7;
	firecountmax=80;
	fcplus=5;
	enemies.curnum=0;
	for (i=0;i<=15;i++)
		createEnemy(77*scale,i*4*scale,4*((i%2)*2-1)*scale,0,type,0);
	//createTimeEvent(startSaucer,0);
}

void level7_dynscript(int i)
{
	if (Enemy.x<=1&&Enemy.speedX<0)
		Enemy.speedX=-Enemy.speedX;
	if (Enemy.x>=149*scale&&Enemy.speedX>0)
		Enemy.speedX=-Enemy.speedX;
}