// Header File
// Created 11/10/2004; 5:24:32 PM

void createBoss(int x,int y,int speedX,int speedY,int type,int phase,int health)
{
	if (bosses.curnum==bosses.max) return;
	BOSS ret={x,y,speedX,speedY,type,phase,health,0,0,0,0,0,0,0,0,0,0};
	if (type==1)
	{
		ret.tag10=XYToDegrees(speedX,speedY,&ret.tag9);//degree angle
		ret.tag7=5;//bullets left
		ret.tag6=0;//firing spree initiated
		ret.tag5=0;//shot distance counter
		ret.tag4=3;//shot distance counter max
	}
	if (type==2)
	{
		ret.tag10=XYToDegrees(speedX,speedY,&ret.tag9);//degree angle
		ret.tag8=0;//shot counter
		ret.tag7=10;//shot counter max
	}
	bosses.p[bosses.curnum]=ret;
	bosses.curnum++;
	drawboss(x,y,type,phase);
}

void drawboss(int x,int y,int type,int phase)
{
	if (type==1)
	{
		draw32(x,y,32,droppericon[phase/4],LCD_MEM,SPRT_XOR);
	}
	if (type==2)
	{
		draw32(x,y,32,saucericon[phase],LCD_MEM,SPRT_XOR);
	}
}

void updateBosses(void)
{
	int i;
	int pd=1;
	int j=0;
	int ex,ey,et,ep;
	int a;
	for (i=0;i<bosses.curnum;i++)
	{
		pd=1;
		drawboss(bosses.p[i].x,bosses.p[i].y,bosses.p[i].type,bosses.p[i].phase);
		ex=bosses.p[i].x;
		ey=bosses.p[i].y;
		et=bosses.p[i].type;
		ep=bosses.p[i].phase;
		bosses.p[i].phase++;
		if (bosses.p[i].phase>maxbossphase[bosses.p[i].type-1]) bosses.p[i].phase=0;
		bosses.p[i].x+=bosses.p[i].speedX;
		bosses.p[i].y+=bosses.p[i].speedY;
		if (bosses.p[i].type==1)
			turn(&(bosses.p[i].speedX),&(bosses.p[i].speedY),&(bosses.p[i].tag10),-bosses.p[i].tag8,bosses.p[i].tag9);
		if (bosses.p[i].type==2)
		{
			a=XYToDegrees(yourShip.x-Boss.x,shipY-40*scale-Boss.y,NULL);
			//gravitate(a,40,&Boss.speedX,&Boss.speedY,&Boss.tag10,Boss.tag9);
			degreesToXY(a,Boss.tag9,0,0,&Boss.speedX,&Boss.speedY,1,1);
		}
		if ((bosses.p[i].x<0)|(bosses.p[i].x>159*scale)|(bosses.p[i].y<0)|(bosses.p[i].y>99*scale))
		{
			//drawboss(ex,ey,et,ep);
			deleteBoss(i+1);
			i--;
			continue;
		}
		ex=bosses.p[i].x;
		ey=bosses.p[i].y;
		et=bosses.p[i].type;
		ep=bosses.p[i].phase;
		for (j=0;j<projectiles.curnum;j++)
		{
			if ((projectiles.p[j].enemy==0)&&ecoldet32(bosses.p[i].x,bosses.p[i].y,bosses.p[i].type,bosses.p[i].phase,projectiles.p[j].x,projectiles.p[j].y,projectiles.p[j].tag))
			{
				drawProjectile(projectiles.p[j].x,projectiles.p[j].y,projectiles.p[j].tag);
				createGraphic(0,projectiles.p[j].x-4*scale,projectiles.p[j].y-4*scale);
				deleteProjectile(j+1);
				bosses.p[i].health-=1;
				j--;
				if (bosses.p[i].health<=0)
				{
					createGraphic(1,bosses.p[i].x+16*scale,bosses.p[i].y+16*scale);
					drawboss(ex,ey,et,ep);
					deleteBoss(i+1);
					i--;
					status.points+=250;
					redrawPoints();
					pd=0;
					break;
				}
			}
		}
		drawboss(ex,ey,et,ep);
		if (pd)
		{
			if (bosses.p[i].type==1)
			{
				if (bosses.p[i].speedX<0)
				{
					if (bosses.p[i].x-yourShip.x<20*scale) bosses.p[i].tag6=1;
				}
				else
				{
					if (yourShip.x-bosses.p[i].x<20*scale) bosses.p[i].tag6=1;
				}
				if (bosses.p[i].tag6&&(bosses.p[i].tag7>0))
				{
					bosses.p[i].tag5++;
					if (bosses.p[i].tag5>=bosses.p[i].tag4)
					{
						bosses.p[i].tag5=0;
						createProjectile(bosses.p[i].x,bosses.p[i].y,0,2*scale,1,0);
						bosses.p[i].tag7--;
					}
				}
			}
		}
	}
}

void deleteBoss(int num)
{
	if (num>bosses.curnum) return;
	int i;
	bosses.curnum--;
	for (i=num;i<=bosses.curnum;i++)
		bosses.p[i-1]=bosses.p[i];
}