// Header File
// Created 11/10/2004; 4:52:10 PM

void startDropper(void);
void startSaucer(void);
void addl4(void);

void startDropper(void)
{
	createBoss(150*scale,0,-3*scale/2,5*scale/2,1,0,2);
	thisBoss.tag8=2;//turn angle
}

void startSaucer(void)
{
	createBoss(0,0,1*scale,1*scale,2,0,3);
}

void addl4(void)
{
	createEnemy(26*scale,0,3*scale,0,4,90);
}

void formation(int theForm)
{
	level[theForm-1].formation();
}

void createEnemy(int x,int y,int speedX,int speedY,int type,int tag)
{
	if (enemies.curnum==enemies.max) return;
	ENEMY ret={x,y,speedX,speedY,type,tag,0,0,0,0,0,0,0,0,0};
	enemies.p[enemies.curnum]=ret;
	enemies.curnum++;
	drawenemy(x,y,type);
	updateGameSpeed();
}

void updateEnemies(void)
{
	int i;
	int pd=1;
	int j=0;
	int ex,ey,et;
	for (i=0;i<enemies.curnum;i++)
	{
		pd=1;
		drawenemy(enemies.p[i].x,enemies.p[i].y,enemies.p[i].type);
		enemies.p[i].x+=enemies.p[i].speedX;
		enemies.p[i].y+=enemies.p[i].speedY;
		level[Enemy.type-1].dynscript(i);
		ex=enemies.p[i].x;
		ey=enemies.p[i].y;
		et=enemies.p[i].type;
		for (j=0;j<projectiles.curnum;j++)
		{
			if ((projectiles.p[j].enemy==0)&&ecoldet(enemies.p[i].x,enemies.p[i].y,enemies.p[i].type,projectiles.p[j].x,projectiles.p[j].y,projectiles.p[j].tag))
			{
				drawenemy(ex,ey,et);
				status.points+=50;
				redrawPoints();
				deleteEnemy(i+1);
				drawProjectile(projectiles.p[j].x,projectiles.p[j].y,projectiles.p[j].tag);
				if (level[Enemy.type-1].iconsize==8)
					createGraphic(0,ex-4*scale,ey-4*scale);
				else
					createGraphic(0,ex,ey);
				deleteProjectile(j+1);
				j--;
				i--;
				pd=0;
				break;
			}
		}
		drawenemy(ex,ey,et);
		if (pd)
		{
			if (yourShip.dead==0&&enemyShotsDisabled==0) firecount++;
			if (firecount>=firecountmax)
			{
				firecount=0;
				createProjectile(enemies.p[i].x,enemies.p[i].y,0,1*scale,1,0);
			}
		}
	}
}

void deleteEnemy(int num)
{
	if (num>enemies.curnum) return;
	int i;
	enemies.curnum--;
	for (i=num;i<=enemies.curnum;i++)
		enemies.p[i-1]=enemies.p[i];
	updateGameSpeed();
	firecountmax-=fcplus;
	if (firecount<0) firecount=0;
}

void wipeOutEnemy(int givePoints)
{
	int i;
	for (i=0;i<enemies.curnum;i++)//the loop will always have i be zero
	{
		drawenemy(Enemy.x,Enemy.y,Enemy.type);
		if (givePoints)
		{
			status.points+=50;
			redrawPoints();
		}
		if (level[Enemy.type-1].iconsize==8)
			createGraphic(0,Enemy.x-4*scale,Enemy.y-4*scale);
		else
			createGraphic(0,Enemy.x,Enemy.y);
		deleteEnemy(i+1);
		i--;
	}
}

void drawenemy(int x,int y,int type)
{
	if (level[type-1].iconsize==8)
		draw8(x,y,8,level[type-1].icon8,LCD_MEM,SPRT_XOR);
	else
		draw16(x,y,16,level[type-1].icon16,LCD_MEM,SPRT_XOR);
}