// Header File
// Created 11/10/2004; 4:51:50 PM

void createProjectile(int x,int y,int speedX,int speedY,int enemy,int tag)
{
	if (projectiles.curnum==projectiles.max) return;
	PROJECTILE ret={x,y,speedX,speedY,enemy,tag};
	projectiles.p[projectiles.curnum]=ret;
	projectiles.curnum++;
	drawProjectile(x,y,tag);
	updateGameSpeed();
}

void updateProjectiles(void)
{
	int i;
	int pd=1;
	for (i=0;i<projectiles.curnum;i++)
	{
		pd=1;
		drawProjectile(projectiles.p[i].x,projectiles.p[i].y,projectiles.p[i].tag);
		projectiles.p[i].x+=projectiles.p[i].speedX;
		projectiles.p[i].y+=projectiles.p[i].speedY;
		if (((projectiles.p[i].x<0))|(projectiles.p[i].x>159*scale)|(projectiles.p[i].y<0)|(projectiles.p[i].y>bottomY))
		{
			deleteProjectile(i+1);
			i--;
			pd=0;
		}
		if (pd) drawProjectile(projectiles.p[i].x,projectiles.p[i].y,projectiles.p[i].tag);
	}
}

void deleteProjectile(int num)
{
	if (num>projectiles.curnum) return;
	if (projectiles.p[num-1].tag==1) createGraphic(3,projectiles.p[num-1].x+4,projectiles.p[num-1].y+4);
	if (projectiles.p[num-1].enemy==0) fshotnum--;
	if (fshotnum<0) fshotnum=0;
	int i;
	projectiles.curnum--;
	for (i=num;i<=projectiles.curnum;i++)
		projectiles.p[i-1]=projectiles.p[i];
	updateGameSpeed();
}

void drawProjectile(int x,int y,int tag)
{
	if (tag==0)
		draw8(x,y,8,smallicons[0],LCD_MEM,SPRT_XOR);
	if (tag==1)
		draw8(x,y,8,rocketicon,LCD_MEM,SPRT_XOR);
}

void cheatProjectile(void)
{
	int s=scale/8,i;
	for (i=-16;i<0;i++) createProjectile(yourShip.x,shipY,s*i,-2*scale,0,0);
	for (i=1;i<16;i++) createProjectile(yourShip.x,shipY,s*i,-2*scale,0,0);
}