// C Source File
// Created 11/4/2004; 8:48:53 PM

// Delete or comment out the items you do not need.
#define COMMENT_STRING         "Place your comment here."
#define COMMENT_PROGRAM_NAME   "Place your program name here."
#define COMMENT_VERSION_STRING "Place your version string here."
#define COMMENT_VERSION_NUMBER 0,0,0,0 /* major, minor, revision, subrevision */

#include <tigcclib.h>
#include "definitions.h"
#include "types.h"
#include "initializations.h"

#include "Levels 1.h"
#include "prototypes.h"
#include "status bars.h"
#include "Projectiles.h"
#include "Enemies.h"
#include "mathematics.h"
#include "Graphics.h"
#include "Goodies.h"
#include "Shields.h"
#include "You.h"
#include "diagnostic.h"
#include "Bosses.h"
#include "TimeEvents.h"
#include "Levels 2.h"
#include "starts and ends.h"

// Main Function
void _main(void)
{
	loadin();
	intro();
	bringShipIn();
	formation(1);
	int keyed=0;
	drawStatus();
	drawBStatus();
	int fsmbuffer=0;
	while (1)
	{
		keyed=0;
		fsmbuffer=fshotmax;
		/*if (gattributes[1]) fsmbuffer*=3;		activating this line allows you to fire again in triple shot
																						right after one bullet hits a target, not three*/
		if (_keytest(RR_ESC)) break;
		if (_keytest(RR_LEFT))
			{
				if (-yourShip.speed<yourShip.arrowDelta) yourShip.speed-=scale;
				keyed=1;
			}
		if (_keytest(RR_RIGHT))
			{
				if (yourShip.speed<yourShip.arrowDelta) yourShip.speed+=scale;
				keyed=1;
			}
		if (_keytest(RR_2ND))
			if ((fdelay==0)&&(yourShip.dead==0)&&(fshotnum<fsmbuffer))
			{
			createProjectile(yourShip.x,shipY,0,-2*scale,0,0);
			if (gattributes[1])
			{
				createProjectile(yourShip.x,shipY,-1*scale/2,-2*scale,0,0);
				createProjectile(yourShip.x,shipY,1*scale/2,-2*scale,0,0);
				fshotnum+=2;
			}
			fshotnum++;
			fdelay=fdelayset;
			}
		if (_keytest(RR_F2))
		{
			if (gattributes[5]>0&&deflectorRunning==0)
			{
				deflectorRunning=1;
				createGraphic(2,0,0);
				gattributes[5]-=1;
				redrawBStatus();
			}
		}
		if (_keytest(RR_F1))
		{
			if (gattributes[6]>0&&timett>=nextRocketTime)
			{
				nextRocketTime=timett+20;
				createProjectile(yourShip.x,shipY,0,-2*scale,0,1);
				gattributes[6]-=1;
				redrawBStatus();
			}
		}
		if (_keytest(RR_X)&&_keytest(RR_BCKSPC)&&(cheatdelay==0))
		{
			if (_keytest(RR_PLUS))
			{
				gattributes[5]=maxWeapon;
				gattributes[6]=maxWeapon;
				cheatEnabled();
				redrawBStatus();
				cheatdelay=cheatdelaymax;
			}
			if (_keytest(RR_0))
			{
				maxgraphs[3]=182;
				cheatEnabled();
				cheatdelay=cheatdelaymax;
			}
			if (_keytest(RR_MINUS))
			{
				enemyShotsDisabled=1-enemyShotsDisabled;
				if (enemyShotsDisabled)
					cheatEnabled();
				else
					cheatDisabled();
				cheatdelay=cheatdelaymax;
			}
			if (_keytest(RR_CLEAR))
			{
				wipeOutEnemy(1);
				cheatEnabled();
				cheatdelay=cheatdelaymax;
			}
		}
		if (keyed==0) yourShip.speed=0;//this line disables gliding
		fdelay--;
		if (fdelay<0) fdelay=0;
		cheatdelay--;
		if (cheatdelay<0) cheatdelay=0;
		if (status.shield%2==1) redrawShield();
		updateShip();
		updateShield();
		updateProjectiles();
		updateEnemies();
		updateGraphics();
		updateGoodies();
		updatePost();
		updateBosses();
		updateTimeEvents();
		checkFormation();
		wait();
	}
	loadout();
}