// Header File
// Created 11/10/2004; 4:52:40 PM

int overlaps(int x1,int y1,int width1,int height1,int x2,int y2,int width2,int height2)
{
	int xover=0;
	int yover=0;
	if (x1+width1>=x2&&x1<x2+width2)
		xover=1;
	if (y1+height1>=y2&&y1<y2+height2)
		yover=1;
	if (xover&&yover) return 1;
	return 0;
}

int ecoldet(int enemyx,int enemyy,int enemytype,int bulletx,int bullety,int bullettag)
{
	char *iconptr=smallicons[0];
	if (bullettag==1) iconptr=rocketicon;
	if (level[enemytype-1].iconsize==8)
		return colDet8(smallicons[enemytype],iconptr,enemyx,enemyy,bulletx,bullety);
	else
		return colDet16(icons[enemytype-2+2],iconptr,enemyx,enemyy,bulletx,bullety);
}

int ecoldetYou(int bulletx,int bullety,int bullettag)
{
	char *iconptr=smallicons[0];
	if (bullettag==1) iconptr=rocketicon;
	return colDet16(icons[1],iconptr,yourShip.x,shipY,bulletx,bullety);
}

int ecoldet32(int enemyx,int enemyy,int enemytype,int phase,int bulletx,int bullety,int bullettag)
{
	char *iconptr=smallicons[0];
	if (bullettag==1) iconptr=rocketicon;
	if (enemytype==1)
		return colDet32(droppericon[phase/4],iconptr,enemyx,enemyy,bulletx,bullety);
	if (enemytype==2)
		return colDet32(saucericon[phase],iconptr,enemyx,enemyy,bulletx,bullety);
	return 0;
}

void clearcds(void)
{
	register long *ptr=(long*)coldetectscreen;
	register long *eptr=ptr+975;
	while (ptr<eptr) *(ptr++)=0;
}

int qcoldet16(int icon1x,int icon1y,int icon2x,int icon2y)
{
	if (icon1x-16*scale>=icon2x) return 0;
	if (icon1x+16*scale<=icon2x) return 0;
	if (icon1y-16*scale>=icon2y) return 0;
	if (icon1y+16*scale<=icon2y) return 0;
	return 1;
}

int colDet32(unsigned long *icon1,unsigned char *icon2,int icon1x,int icon1y,int icon2x,int icon2y)
{
	icon1x/=scale;
	icon1y/=scale;
	icon2x/=scale;
	icon2y/=scale;
	if (icon1x-8>=icon2x) return 0;
	if (icon1x+32<=icon2x) return 0;
	if (icon1y-8>=icon2y) return 0;
	if (icon1y+32<=icon2y) return 0;
	int mm=0;
	if (icon1x<icon2x)
		mm=icon1x%8;
	else
		mm=icon2x%8;
	icon1x-=mm;
	icon2x-=mm;
	Sprite32(icon1x,icon1y,32,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	int final=0;
	register unsigned char *ptrint=coldetectscreen+icon1y*30+icon1x/8;
	register unsigned char *ptrchar=coldetectscreen+icon2y*30+icon2x/8;
	register unsigned char *iconbint=(char*)icon1;
	register unsigned char *iconbchar=icon2;
	register unsigned char *eptrchar=ptrchar+240;
	register unsigned char *eptrint=ptrint+960;
	register unsigned char ibuffer=0;
	if (icon1x%8==0)	//ship is left of bullet
	{
		while (ptrint<eptrint)
		{
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint++;
			iconbint++;
			//
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint++;
			iconbint++;
			//
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint++;
			iconbint++;
			//
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint+=27;
			iconbint++;
		}
	}
	else//if (icon2x%8==0)	//ship is right of bullet
	{
		while (ptrchar<eptrchar)
		{
			ibuffer=(~*ptrchar)&(*iconbchar);
			if (ibuffer>0) final=1;
			ptrchar+=30;
			iconbchar++;
		}
	}
	//postcds();	//use this line for diagnosing collision errors
	Sprite32(icon1x,icon1y,32,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	return final;
}

int colDet16(unsigned int *icon1,unsigned char *icon2,int icon1x,int icon1y,int icon2x,int icon2y)
{
	icon1x/=scale;
	icon1y/=scale;
	icon2x/=scale;
	icon2y/=scale;
	if (icon1x-8>=icon2x) return 0;
	if (icon1x+16<=icon2x) return 0;
	if (icon1y-8>=icon2y) return 0;
	if (icon1y+16<=icon2y) return 0;
	int mm=0;
	if (icon1x<icon2x)
		mm=icon1x%8;
	else
		mm=icon2x%8;
	icon1x-=mm;
	icon2x-=mm;
	Sprite16(icon1x,icon1y,16,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	int final=0;
	register unsigned char *ptrint=coldetectscreen+icon1y*30+icon1x/8;
	register unsigned char *ptrchar=coldetectscreen+icon2y*30+icon2x/8;
	register unsigned char *iconbint=(char*)icon1;
	register unsigned char *iconbchar=icon2;
	register unsigned char *eptrchar=ptrchar+240;
	register unsigned char *eptrint=ptrint+480;
	register unsigned char ibuffer=0;
	if (icon1x%8==0)	//ship is left of bullet
	{
		while (ptrint<eptrint)
		{
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint++;
			iconbint++;
			ibuffer=(~*ptrint)&(*iconbint);
			if (ibuffer>0) final=1;
			ptrint+=29;
			iconbint++;
		}
	}
	else//if (icon2x%8==0)	//ship is right of bullet
	{
		while (ptrchar<eptrchar)
		{
			ibuffer=(~*ptrchar)&(*iconbchar);
			if (ibuffer>0) final=1;
			ptrchar+=30;
			iconbchar++;
		}
	}
	//postcds();	//use this line for diagnosing collision errors
	Sprite16(icon1x,icon1y,16,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	return final;
}

int colDet8(unsigned char *icon1,unsigned char *icon2,int icon1x,int icon1y,int icon2x,int icon2y)
{
	icon1x/=scale;
	icon1y/=scale;
	icon2x/=scale;
	icon2y/=scale;
	if (icon1x-8>=icon2x) return 0;
	if (icon1x+8<=icon2x) return 0;
	if (icon1y-8>=icon2y) return 0;
	if (icon1y+8<=icon2y) return 0;
	int mm=0;
	if (icon1x<icon2x)
		mm=icon1x%8;
	else
		mm=icon2x%8;
	icon1x-=mm;
	icon2x-=mm;
	Sprite8(icon1x,icon1y,8,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	int final=0;
	register unsigned char *ptr=NULL;
	register unsigned char *iconb;
	if (icon1x%8==0)
	{
		ptr=coldetectscreen+icon1y*30+icon1x/8;
		iconb=icon1;
	}
	else
	{
		ptr=coldetectscreen+icon2y*30+icon2x/8;
		iconb=icon2;
	}
	register unsigned char *eptr=ptr+240;
	while (ptr<eptr)
		{
			if (((~*ptr)&(*iconb))>0) final=1;
			ptr+=30;
			iconb++;
		}
	Sprite8(icon1x,icon1y,8,icon1,coldetectscreen,SPRT_XOR);
	Sprite8(icon2x,icon2y,8,icon2,coldetectscreen,SPRT_XOR);
	return final;
}

//all circle routines start at 6 o' clock and go counter clockwise as the degrees go up

void convToCircle(int degrees,int *x,int *y)
{
	degreesToXY(degrees,20*scale,75*scale,25*scale,x,y,3,1);
}

void degreesToXY(int degrees,int radius,int xcenter,int ycenter,int *x,int *y,int xmult,int ymult)//xcenter might be 75, ycenter might be 25
{
	long dv65536=65536/radius;
	int negate=0;
	if (degrees>=180) negate=1;
	long buffer=sinvals[(degrees%360)]/dv65536;
	*x=buffer*xmult+xcenter;
	degrees+=90;
	buffer=sinvals[(degrees%360)]/dv65536;
	*y=buffer*ymult+ycenter;
}

void turn(int *speedX,int *speedY,int *degrees,int angle,int radius)
{
	*degrees+=angle;
	if (*degrees<0) *degrees+=360;
	*degrees%=360;
	degreesToXY(*degrees,radius,0,0,speedX,speedY,1,1);
}

//destDegrees is the direction that this will try to turn to
//deltaDegrees is the speed of turning it has to work with
void gravitate(int destDegrees,int deltaDegrees,int *speedX,int *speedY,int *degrees,int radius)
{
	int leftTurnDist=destDegrees-*degrees;
	if (leftTurnDist<0) leftTurnDist=360+leftTurnDist;
	int rightTurnDist=360-leftTurnDist;
	if (leftTurnDist<=180)
	{
		if (leftTurnDist<deltaDegrees)
			*degrees=destDegrees;
		else
			*degrees+=deltaDegrees;
	}
	else
	{
		if (rightTurnDist<deltaDegrees)
			*degrees=destDegrees;
		else
			*degrees-=deltaDegrees;
	}
	if (*degrees<0) *degrees+=360;
	*degrees%=360;
	degreesToXY(*degrees,radius,0,0,speedX,speedY,1,1);
}

int XYToDegrees(int x,int y,int *radius)
{
	int ret=0;
	if (y==0)
	{
		if (x>0)
			ret=90;
		else
			{
				ret=270;
				x=-x;
			}
		if (radius!=NULL) *radius=x;
		return ret;
	}
	if (x==0)
	{
		if (y>0)
			ret=0;
		else
			{
				ret=180;
				y=-x;
			}
		if (radius!=NULL) *radius=y;
		return ret;
	}
	char nx=0,ny=0;
	if (x<0)
	{
		x=-x;
		nx=1;
	}
	if (y<0)
	{
		y=-y;
		ny=1;
	}
	if (x==y) ret=45;
	else
	{
		long xyd;
		if (x<y)
			{
				xyd=x*100/y;
				ret=atanvals[xyd%100];
			}
		else
			{
				xyd=y*100/x;
				ret=90-atanvals[xyd%100];
			}
	}
	if (ny) ret=180-ret;
	if (nx) ret=360-ret;
	long xbuf=x;
	long ybuf=y;
	if (radius!=NULL) *radius=qsqrt(xbuf*xbuf+ybuf*ybuf);
	return ret%360;
}

int qsqrt(long x)
{
	long i;
	i=0;
	while (i*i<=x) i++;
	return (int)i-1;
}