// Header File
// Created 11/10/2004; 4:57:35 PM

void loadin(void)
{
	//OSSetSR (0x0700);
	OldInt1 = GetIntVec (AUTO_INT_1);
	OldInt6 = GetIntVec (AUTO_INT_6);
  SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
  SetIntVec (AUTO_INT_6, MyInt6);
	coldetectscreen=malloc(LCD_SIZE+60);
	tScrRect=&(SCR_RECT){{0,0,159,bstatlineg-1}};
	clearcds();
	randomize();
	char *lcdme=LCD_MEM+LCD_SIZE-2;
	lcdMemEnd=(int*)lcdme;
	speed=gameSpeed;
	yourShip.x=shipCenter;
	yourShip.arrowDelta=3*scale;
	yourShip.speed=0;
	yourShip.dead=0;
	projectiles.curnum=0;
	projectiles.max=projectmax;
	enemies.curnum=0;
	enemies.max=200;
	graphics.curnum=0;
	graphics.max=graphmax;
	goodies.curnum=0;
	goodies.max=goodiemax;
	bosses.curnum=0;
	bosses.max=bossmax;
	timetable.max=timeeventmax;
	clearTimeTable();
	bincount=0;
	goodiecount=500;
	goodiecountmax=1000;
	numofattributes=7;
	maxnumofattributes=7;
	fdelay=0;
	fdelayset=10;
	fshotnum=0;
	fshotmax=1;
	firecount=0;
	firecountmax=0;
	fcplus=0;
	enemyShotsDisabled=0;
	deadcount=0;
	enemydeadcount=0;
	curFormation=1;
	numOfFormations=numOfLevels;
	message.theText=NULL;
	message.timeleft=0;
	status.left=statustext[0];
	status.center=statustext[1];
	status.right=statustext[2];
	status.points=0;
	status.lives=3;
	status.shield=0;
	cheatdelay=0;
	maxgraphs[0]=6;
	maxgraphs[1]=12;
	maxgraphs[2]=100;
	maxgraphs[3]=20;
	sprintf(status.left,"%ld%c",status.points,'\0');
	sprintf(status.center,"Level %d%c",curFormation,'\0');
	sprintf(status.right,"Lives: %d%c",status.lives,'\0');
	clearAttributes();
}

void checkFormation(void)
{
	if ((enemies.curnum)==0)
	{
		enemydeadcount++;
		if (enemydeadcount>=deadtime)
		{
			enemydeadcount=0;
			curFormation++;
			if (curFormation>numOfFormations) curFormation=1;
			intro();
			if (yourShip.dead==0) bringShipIn();
			yourShip.x=shipCenter;
			yourShip.speed=0;
			formation(curFormation);
			sprintf(status.center,"Level %d%c",curFormation,'\0');
			drawStatus();
			drawBStatus();
			if (status.shield%2==1) redrawShield();
		}
	}
}

void bringShipIn(void)
{
	int i;
	speed=18000;
	for (i=32*scale;i<=shipY;i+=scale)
	{
		draw16(shipCenter,i,16,icons[1],LCD_MEM,SPRT_XOR);
		wait();
		if (i<shipY) draw16(shipCenter,i,16,icons[1],LCD_MEM,SPRT_XOR);
	}
	speed=gameSpeed;
}

void intro(void)
{
	long i;
	projectiles.curnum=0;
	enemies.curnum=0;
	graphics.curnum=0;
	clearTimeTable();
	bosses.curnum=0;
	message.timeleft=0;
	deflectorRunning=0;
	nextRocketTime=0;
	fshotnum=0;
	speed=50000;
	unsigned char counter=0;
	for (i=0;i<=640;i++)
	{
		comedown(0);
		counter++;
		if ((i<630)&&(counter%16==0))
		{
			draw16(random(159*scale),0,16,icons[0],LCD_MEM,A_NORMAL);
		}
		wait();
		if (speed>0) speed-=5000;
	}
	speed=gameSpeed;
	for (i=0;i<goodies.curnum;i++)
	{
		goodies.p[i].y-=30*scale;
		if (goodies.p[i].y<0) goodies.p[i].y=0;
		draw16(goodies.p[i].x,goodies.p[i].y,16,goodieicon,LCD_MEM,SPRT_XOR);
	}
}

void gameover(void)
{
	loadout();
	exit(0);
}

void loadout(void)
{
	free(coldetectscreen);
	SetIntVec (AUTO_INT_1, OldInt1);
	SetIntVec (AUTO_INT_6, OldInt6);
	//OSSetSR (0x0000);
}

void comedown(char newbyte)
{
	register int *buffer=lcdMemEnd-15;
	register int *ebuffer=LCD_MEM;
	while (buffer>=ebuffer)
	{
		*(buffer+15)=*buffer;
		buffer--;
	}
	buffer=ebuffer;
	ebuffer=buffer+15;
	while (buffer<ebuffer)
	{
		*buffer=newbyte;
		buffer++;
	}
}