// Header File
// Created 11/10/2004; 4:33:38 PM

typedef struct
{
	int x;
	int speed;
	int arrowDelta;
	int dead;
} YOURSHIP;

typedef struct
{
	void (*formation)(void);
	void (*dynscript)(int i);
	int iconsize;//8 or 16
	unsigned char	*icon8;
	unsigned int	*icon16;	//only one icon pointer needs to be initialized because each level only gets one icon.
}	LEVEL;

typedef struct
{
	int x;
	int y;
	int speedX;
	int speedY;
	int type;
	int tag;
	int tag2;
	int tag3;
	int tag4;
	int tag5;
	int tag6;
	int tag7;
	int tag8;
	int tag9;
	int tag10;
} ENEMY;

typedef struct
{
	ENEMY p[200];
	int curnum;
	int max;
} ENEMIES;    //both curnum and max are 1-based, not 0-based.

typedef struct
{
	int x;
	int y;
	int speedX;
	int speedY;
	int enemy;
	int tag;
} PROJECTILE;

typedef struct
{
	PROJECTILE p[projectmax];
	int curnum;
	int max;    //both curnum and max are 1-based, not 0-based.
} PROJECTILES;

typedef struct
{
	int type;
	int x,y;
	int phase;  //phase is 0-based.
} GRAPHIC;

typedef struct
{
	GRAPHIC p[graphmax];
	int curnum;
	int max;    //both curnum and max are 1-based, not 0-based.
} GRAPHICS;

typedef struct
{
	int attribute;
	int x;
	int y;
} GOODIE;

typedef struct
{
	GOODIE p[goodiemax];
	int curnum;
	int max;		//both curnum and max are 1-based, not 0-based.
}	GOODIES;

typedef struct
{
	int x;
	int y;
	int speedX;
	int speedY;
	int type;			//one-based
	int phase;		//zero-based
	int health;
	int tag1;
	int tag2;
	int tag3;
	int tag4;
	int tag5;
	int tag6;
	int tag7;
	int tag8;
	int tag9;
	int tag10;
} BOSS;

typedef struct
{
	BOSS p[goodiemax];
	int curnum;
	int max;		//both curnum and max are 1-based, not 0-based.
} BOSSES;

typedef struct
{
	void (*prog)(void);
	long time;
}	TIMEEVENT;

typedef struct
{
	TIMEEVENT p[timeeventmax];
	int curnum;
	int max;
}	TIMETABLE;

typedef struct
{
	char *theText;
	int timeleft;		//when timeleft reaches 0, the text is hidden
}	MESSAGE;

typedef struct
{
	char *left;		//points
	char *center;	//Level (formation)
	char *right;		//lives
	long points;
	char lives;
	int shield;
}	STATUS;

typedef struct
{
	int tripleshot;
	int rapidfire;
	int speed;
} BSTATUSVARS;